package com.ademicon.repository.auth;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import com.ademicon.model.auth.AccessModel;
import com.ademicon.service.ConnectionService;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;

public class AccessRepository {

    public AccessModel find() throws Exception {

        String queryString = "SELECT PARAMETRO, VALOR_STR FROM ADE_006_PARM_CRED_VEIC WHERE PARAMETRO IN ('PLACETI_URL_BASE', 'PLACETI_URL_TOKEN', 'PLACETI_USER_TOKEN')";

        try (Connection conn = ConnectionService.getConnection();
                PreparedStatement preparedStatement = conn.prepareStatement(queryString);
                ResultSet resultSet = preparedStatement.executeQuery()) {

            String json = "{";
            while (resultSet.next()) {
                json += "\"" + resultSet.getString("PARAMETRO") + "\":\"" + resultSet.getString("VALOR_STR") + "\",";

            }
            json = json.substring(0, json.lastIndexOf(",")) + "}";
            ObjectMapper mapper = new ObjectMapper();
            mapper.configure(DeserializationFeature.FAIL_ON_UNKNOWN_PROPERTIES, false);
            return mapper.readValue(json, AccessModel.class);

        } catch (Exception e) {
            throw e;

        }
    }
}
