package com.ademicon.repository.auth;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

import com.ademicon.model.auth.TokenModel;
import com.ademicon.service.ConnectionService;

public class TokenRepository {

    public Integer save(TokenModel token) throws Exception {

        String queryString = "UPDATE ADE_006_TOKEN_CONTROL SET ACCESS_TOKEN = ?, EXPIRES_IN = ? WHERE API = 'PLACETI'";

        try (Connection conn = ConnectionService.getConnection();
                PreparedStatement preparedStatement = conn.prepareStatement(queryString);) {
            preparedStatement.setString(1, token.getAccess_token());
            preparedStatement.setString(2, token.getExpires_in().toString().substring(0, 19));
            return preparedStatement.executeUpdate();

        } catch (Exception e) {
            throw e;

        }
    }

    public TokenModel find() throws Exception {

        String queryString = "SELECT * FROM ADE_006_TOKEN_CONTROL WHERE API = 'PLACETI'";

        try (Connection conn = ConnectionService.getConnection();
                PreparedStatement preparedStatement = conn.prepareStatement(queryString);
                ResultSet resultSet = preparedStatement.executeQuery()) {

            TokenModel newTokenModel = new TokenModel();
            if (resultSet.next()) {
                newTokenModel.setAccess_token(resultSet.getString("ACCESS_TOKEN"));
                LocalDateTime localDateTime = getLocalDateTime(resultSet.getString("EXPIRES_IN"));
                newTokenModel.setExpires_in(localDateTime);

            } else {
                newTokenModel.setAccess_token("");
                LocalDateTime localDateTime = getLocalDateTime("2000-01-01T00:00:00");
                newTokenModel.setExpires_in(localDateTime);
                
            }
            return newTokenModel;

        } catch (Exception e) {
            throw e;

        }
    }

    private LocalDateTime getLocalDateTime(String localDateTimeString) {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ss");
        LocalDateTime localDateTime = LocalDateTime.of(1900, 12, 31, 12, 0, 0);
        if (localDateTimeString.length() > 0) {
            localDateTime = LocalDateTime.parse(localDateTimeString.substring(0, 19), formatter);
        }
        return localDateTime;
    }
}
